format	PE GUI 4.0
entry	MyEntry

include '\Program Files\fasm\include\macro\masm.inc'
include '\Program Files\fasm\include\Win32axp.inc'
include 'FC.inc'

section '.data'		data		readable	writeable
			_ClassName	db	'FC', 0
			_AppName	db	'FC', 0
			_toolclass	db	'ToolbarWindow32', 0
			_Created	db	'File Created', 0
			_Deleted	db	'File Removed', 0
			_Modified	db	'File Modified', 0
			_RenamedOld	db	'File Renamed/Old Name', 0
			_RenamedNew	db	'File Renamed/New Name', 0
				_U2CD	db	'UNABLE TO ACCESS DIRECTORY!', 0
			_ttCreate	db	'Create New File', 0
			_ttDelete	db	'Delete A File', 0
			_ttModify	db	'Modify A File', 0
			_ttRename	db	'Rename A File', 0
			_ttMoveFr	db	'Move File From This Dir', 0
			_ttMoveTo	db	'Move File To This Dir', 0
				_ttExit	db	'Exit!', 0
	_ListViewClassName	db	"SysListView32", 0
				_RawFN	db	'RawFN.fc', 0
			_CreateFN	db	'CreateFN.fc', 0
			_RenameFN	db	'RenameFN.fc', 0
				_New	db	'FCNew', 0
				_Root	db	'\', 0
			_LVHeading1	db	'File', 0
			_LVHeading2	db	'Action', 0
		_OtherAction	db	'Some Other Action took place!', 0

section '.bss'		readable	writeable
		gIst	dd	?
		gWnd	dd	?
		gHwnd	dd	?
		hAccel	dd	?
		hImage	dd	?
	hImageList	dd	?					;Handle for Image List
	hwndTool	dd	?					;Handle for ToolBar window
	ThreadID	dd	?
	ThreadHand	dd	?
			id	dd	?
			cnt	dd	?
		DRtimer	dd	?
		hList	dd	?
		hRawFN	dd	?
	bufRawFN	dd	?
		bufNOBW	dd	?
	gListAct	dd	?
		gDone	dd	?
		str_buf	rb 80
	TA_PathBuf	rb	MAX_PATH
	PathBuf	rb	MAX_PATH
	TmpPath	rb	MAX_PATH
align 32
	lvc			LVCOLUMN
align 32
	lvi			LVITEM
align 32
	tbb			TBBUTTON
align 32
	wc			WNDCLASSEX
align 32
	msg			MSG


section '.code'		code		readable	executable

MyEntry:
	call	OnlyOneInstance					;Assure only one instance
	.if	eax, e, 0
		invoke	ExitProcess, 1
	.endif
	invoke	InitCommonControls
	invoke	GetModuleHandle, 0
	mov		[gIst], eax
	MakeWindow
	CreateToolBar
	CreateListView
	.while TRUE
		invoke GetMessage, msg, NULL, 0, 0
		.if eax, e, 0
			jmp	@f
		.endif
		invoke	TranslateAccelerator, [gWnd], [hAccel], msg
		.if	eax, e, 0
			invoke	IsDialogMessage, [gWnd], msg
			.if eax, e, 0
				invoke TranslateMessage, msg
				invoke DispatchMessage, msg
			.endif
		.endif
	.endw
@@:
	mov     eax, [msg.wParam]
	invoke	ExitProcess, 0

WndProc	proc	uses ebx, hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
local	local__buf[MAX_PATH]:WORD
	.if		[wmsg], e, WM_DESTROY
			invoke	CloseHandle, [ThreadHand]
			invoke	PostQuitMessage, NULL
	.elseif	[wmsg], e, WM_COMMAND
			mov		eax, [wparam]
			cwde
			.if	eax, e, IDM_EXIT2
				invoke	SendMessage, [hwnd], WM_DESTROY, 0, 0
			.elseif	eax, e, IDM_CREATE
				FC_Create											;Creates the file 'CreateFN.fc' in this apps' dir
			.elseif	eax, e, IDM_DELETE
				FC_Delete
			.elseif	eax, e, IDM_MODIFY
				FC_Modify
			.elseif	eax, e, IDM_MOVEFR
				FC_MoveFr
			.elseif	eax, e, IDM_MOVETO
				FC_MoveTo
			.elseif	eax, e, IDM_RENAME
				FC_Rename
			.endif
	.elseif	[wmsg], e, WM_CREATE
			mov		[DRtimer], 0
			invoke	SetTimer, [hwnd], 4321, 100, NULL
	.elseif	[wmsg], e, WM_TIMER
		.if [DRtimer], ne, 0
			invoke	KillTimer, [hwnd], 5432
			DelayRename
			mov		[DRtimer], 0
		.else
			invoke	KillTimer, [hwnd], 4321
			CheckFiles											;returns 0 if unbale to setup essential file
			.if	eax, e, 0
				invoke	SendMessage, [hwnd], WM_DESTROY, 0, 0
			.endif
			mov		eax, ThreadProc
			invoke	CreateThread, NULL, NULL, eax,\
					NULL, NORMAL_PRIORITY_CLASS,\
					ThreadID
			mov		[ThreadHand], eax
		.endif
	.elseif	[wmsg], e, WM_NOTIFY
			mov	ebx, [lparam]
			.if	NMHDR.code, e, TTN_NEEDTEXT				;ToolBar ToolTips
				.if NMHDR.idFrom, e, IDM_CREATE
					push	_ttCreate
				.elseif NMHDR.idFrom, e, IDM_DELETE
					push	_ttDelete
				.elseif NMHDR.idFrom, e, IDM_MODIFY
					push	_ttModify
				.elseif NMHDR.idFrom, e, IDM_RENAME
					push	_ttRename
				.elseif NMHDR.idFrom, e, IDM_MOVEFR
					push	_ttMoveFr
				.elseif NMHDR.idFrom, e, IDM_MOVETO
					push	_ttMoveTo
				.elseif NMHDR.idFrom, e, IDM_EXIT2
					push	_ttExit
				.else
					mov		eax, 1
					jmp		.dir_out
				.endif
				pop		TOOLTIPTEXT.lpszText
			.endif
	.elseif	[wmsg], e, WM_SIZE
			mov		eax, [lparam]
			mov		edx, eax
			and		eax, 0ffffh
			shr		edx, 16
			sub		edx, 44
			invoke	MoveWindow, [hList], 0, 46, eax, edx, TRUE
	.else
			invoke	DefWindowProc, [hwnd], [wmsg], [wparam], [lparam]
			jmp		.dir_out
	.endif
	xor		eax, eax
.dir_out:
	ret
WndProc	endp

ThreadProc	proc
local	hRDCW:DWORD
local	numBR:DWORD
local	another:DWORD
local	local__buf[MAX_PATH]:WORD
local	ansi__buf[MAX_PATH]:BYTE
local	bufRDCW[1024]:FILE_NOTIFY_INFORMATION			;FILE_NOTIFY_INFORMATION

;Code 'borrowed' from http://www.codeguru.com/Cpp/W-P/files/article.php/c4467/
;http://blogs.msdn.com/ericgu/archive/2005/10/07/478396.aspx
;http://www.codeproject.com/file/FileSpyArticle.asp

;these next 5 lines to touch all pages reserved for locals
	mov	eax, ebp			;eax here 3a10h larger than esp
	.while eax, ae, esp
		mov dword [eax], 0	;touch the page with a 0 so as not to violate gaurd page
		sub eax, 1024		;should we check the next page?
	.endw
	invoke	CreateFile,													\	;Specify Directory to monitor
			TA_PathBuf,													\	;path to monitor
			FILE_LIST_DIRECTORY,										\	;access (read/write) mode
			FILE_SHARE_READ or FILE_SHARE_DELETE or FILE_SHARE_WRITE,	\	;share mode
			NULL, 														\	;security descriptor
			OPEN_EXISTING,												\	;how to create
			FILE_FLAG_BACKUP_SEMANTICS,									\	;file attributes
			NULL															;file with attributes to copy
	.if eax, e, INVALID_HANDLE_VALUE
		invoke	MessageBox, 0, _U2CD, NULL, MB_OK
		invoke	ExitThread, 1
	.endif
	mov		[hRDCW], eax								;Handle for Directory to monitor
	mov		[lvi.iItem], -1
	.while	TRUE										;Constantly monitor
		lea		eax, [bufRDCW]
		lea		ecx, [numBR]
		invoke	ReadDirectoryChangesW,						\
				[hRDCW],									\;handle to directory
				eax,										\;&Buffer, read results buffer
				1024 * sizeof.FILE_NOTIFY_INFORMATION,		\;length of buffer
				FALSE,										\;monitoring option, don't monitor subdirectories
				FILE_NOTIFY_CHANGE_SECURITY or				\;changes to watch
				FILE_NOTIFY_CHANGE_CREATION or				\;changes to watch
				FILE_NOTIFY_CHANGE_ATTRIBUTES or			\
				FILE_NOTIFY_CHANGE_LAST_ACCESS or			\
				FILE_NOTIFY_CHANGE_LAST_WRITE or			\
				FILE_NOTIFY_CHANGE_SIZE or					\
				FILE_NOTIFY_CHANGE_DIR_NAME or				\
				FILE_NOTIFY_CHANGE_FILE_NAME,				\;filter conditions
				ecx,										\;&BytesReturned bytes returned
				NULL,										\;overlapped buffer
				NULL										;completion routine
		mov		eax, [numBR]
		push	ebx
		push	edi
		push	esi
		lea		ebx, [bufRDCW]		;ebx used to store address of 'this' FILE_NOTIFY_INFORMATION struct
		.repeat
			mov		edi, [ebx]
			mov		esi, ebx		;eax point to current struct
			add		esi, 12			;eax point to 'filename'
			push	edi
			lea		edi, [local__buf]
			mov		ecx, dword [ebx + 8]
			rep		movsb
			mov		[edi], word 0										;terminate UNICODE string with 0
			pop		edi
;filename is added to column 1 using LVM_INSERTITEM
;			.if [gListAct]
			.if 1
				mov		[lvi.mask], LVIF_TEXT
				inc		[lvi.iItem]
				mov		[lvi.iSubItem], 0
				invoke	WideCharToMultiByte, CP_ACP, NULL, addr local__buf, -1, addr ansi__buf, MAX_PATH, NULL, NULL
				lea		eax, [ansi__buf]
				mov		[lvi.pszText], eax
				invoke	SendMessage, [hList], LVM_INSERTITEM, 0, lvi
				mov	ecx, [ebx + 4]										;action for 'this' notification
;Action is added to column 2 using LVM_SETITEM
				.if ecx, e, FILE_ACTION_ADDED
					push	_Created
				.elseif ecx, e, FILE_ACTION_REMOVED
					push	_Deleted
				.elseif ecx, e, FILE_ACTION_MODIFIED
					push	_Modified
				.elseif ecx, e, FILE_ACTION_RENAMED_OLD_NAME
					push	_RenamedOld
				.elseif ecx, e, FILE_ACTION_RENAMED_NEW_NAME
					push	_RenamedNew
				.else
					stdcall	jdwtoa, ecx, str_buf, 0
					push	str_buf
					invoke	MessageBox, 0, str_buf, _OtherAction, MB_OK
				.endif
				mov		[lvi.iSubItem], 1
				pop		eax
				mov		[lvi.pszText], eax
				invoke	SendMessage, [hList], LVM_SETITEM, 0, lvi	;2
			.endif
			add	ebx, edi
		.until	edi, e, 0
		mov		[gDone], 1
		pop		esi
		pop		edi
		pop		ebx
	.endw
	ret
ThreadProc	endp

OnlyOneInstance	proc
local	hSemaphore:DWORD
	invoke	CreateSemaphore, NULL, 0, 1, _AppName
	mov		[hSemaphore], eax
	invoke	GetLastError
	.if eax, e, ERROR_ALREADY_EXISTS
		invoke	CloseHandle, [hSemaphore]
	.else
		.if eax, e, ERROR_SUCCESS				; created Semaphore will
			mov	eax, TRUE						; prevent other instances
			jmp	.Return							; return TRUE to continue
		.endif
	.endif
	xor		eax, eax					; return FALSE (eax=0) to exit
.Return:
	ret

OnlyOneInstance	endp


section '.idata'	import		data		readable	writeable

	library	kernel32, 	'kernel32', \
			kernel32W,	'kernel32', \
			user32, 	'user32', \
			comctl32, 	'comctl32', \
			gdi32, 		'gdi32'

	include	'\progra~1\fasm\include\apia\kernel32.inc'
	include	'\progra~1\fasm\include\apia\user32.inc'
	include	'\progra~1\fasm\include\apia\comctl32.inc'
	include	'\progra~1\fasm\include\apia\gdi32.inc'
	
	import	kernel32W, \
			ReadDirectoryChangesW, 'ReadDirectoryChangesW'

section '.rsrc'		resource	data		readable

	RT_MANIFEST = 24
	
	IDM_CREATE	=	101
	IDM_DELETE	=	102
	IDM_MODIFY	=	103
	IDM_RENAME	=	104
	IDM_MOVEFR	=	105
	IDM_MOVETO	=	106
	IDM_EXIT2	=	107

	IDB_CREATE	=	701
	IDB_DELETE	=	702
	IDB_MODIFY	=	703
	IDB_RENAME	=	704
	IDB_MOVEFR	=	705
	IDB_MOVETO	=	706
	IDB_EXIT2	=	707

	; resource directory

	directory RT_MENU, menus, \
		RT_ICON, icons, \
		RT_GROUP_ICON, group_icons, \
		RT_VERSION, versions, \
		RT_MANIFEST, manifests, \
		RT_BITMAP, bitmaps

	; resource subdirectories

	resource menus, \
		37, LANG_ENGLISH+SUBLANG_DEFAULT, main_menu

	resource icons, \
		1, LANG_NEUTRAL, icon_data

	resource group_icons, \
		2, LANG_NEUTRAL, main_icon

	resource versions, \
		1, LANG_NEUTRAL, version

	resource manifests,\
		1, LANG_ENGLISH+SUBLANG_DEFAULT, manifest
	
	resource bitmaps, \
		IDB_CREATE ,LANG_NEUTRAL, create_bitmap, \
		IDB_DELETE ,LANG_NEUTRAL, delete_bitmap, \
		IDB_MODIFY ,LANG_NEUTRAL, modify_bitmap, \
		IDB_RENAME ,LANG_NEUTRAL, rename_bitmap, \
		IDB_MOVEFR ,LANG_NEUTRAL, movefr_bitmap, \
		IDB_MOVETO ,LANG_NEUTRAL, moveto_bitmap, \
		IDB_EXIT2 ,LANG_NEUTRAL, exit2_bitmap

	menu main_menu
		menuitem '&File', 0, MFR_POPUP + MFR_END
			menuitem '&Create', IDM_CREATE
			menuitem '&Delete', IDM_DELETE
			menuitem '&Modify', IDM_MODIFY
			menuitem '&Rename', IDM_RENAME
			menuitem '&MoveFrom', IDM_MOVEFR
			menuitem 'Move&To', IDM_MOVETO
			menuitem 'E&xit', IDM_EXIT2,MFR_END

	icon main_icon, icon_data, 'res\\TC.ICO'

	versioninfo version, VOS__WINDOWS32, VFT_APP, VFT2_UNKNOWN, LANG_ENGLISH+SUBLANG_DEFAULT, 0 , \
		'FileDescription', 'File Change Notification', \
		'LegalCopyright', 'No rights reserved.', \
		'FileVersion', '1.0.1', \
		'ProductVersion', '1.0.1', \
		'OriginalFilename', 'FC.EXE'

	resdata manifest
		db '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>', 13, 10
		db '<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0">', 13, 10
		db '<assemblyIdentity name="FC.exe" processorArchitecture="x86" version="5.1.0.0" type="win32"/> ', 13, 10
		db '<description>no</description>', 13, 10
		db '<dependency>', 13, 10
		db '<dependentAssembly>', 13, 10
		db '<assemblyIdentity type="win32" name="Microsoft.Windows.Common-Controls" version="6.0.0.0" processorArchitecture="x86" publicKeyToken="6595b64144ccf1df" language="*" />', 13, 10
		db '</dependentAssembly>', 13, 10
		db '</dependency>', 13, 10
		db '</assembly>', 13, 10
	endres

	bitmap	create_bitmap, 'res\Create.bmp'
	bitmap	delete_bitmap, 'res\Delete.bmp'
	bitmap	modify_bitmap, 'res\Modify.bmp'
	bitmap	rename_bitmap, 'res\Rename.bmp'
	bitmap	movefr_bitmap, 'res\MoveFrom.bmp'
	bitmap	moveto_bitmap, 'res\MoveTo.bmp'
	bitmap	exit2_bitmap, 'res\Exit2.bmp'
