	ERROR_ALREADY_EXISTS	= 183
	ERROR_SUCCESS			= 0
	IDI_MAIN				= 2
	IDM_EXIT				= 102
	INFINITE				= -1
	MainWindHeight			= 500
	MainWindWidth			= 750
	MAX_PATH				= 260
	SEM_FAILCRITICALERRORS	= 1
	FILE_LIST_DIRECTORY		= 1
	FILE_NOTIFY_CHANGE_FILE_NAME	= 1h
	FILE_NOTIFY_CHANGE_DIR_NAME		= 2h
	FILE_NOTIFY_CHANGE_ATTRIBUTES	= 4h
	FILE_NOTIFY_CHANGE_SIZE			= 8h
	FILE_NOTIFY_CHANGE_LAST_WRITE	= 10h
	FILE_NOTIFY_CHANGE_LAST_ACCESS	= 20h
	FILE_NOTIFY_CHANGE_CREATION     = 40h
	FILE_NOTIFY_CHANGE_SECURITY		= 100h
	FILE_ACTION_ADDED				= 1h
	FILE_ACTION_REMOVED				= 2h
	FILE_ACTION_MODIFIED			= 3h
	FILE_ACTION_RENAMED_OLD_NAME	= 4h
	FILE_ACTION_RENAMED_NEW_NAME	= 5h
	CP_ACP							= 0			;default to ANSI code page
	CP_UTF7							= 65000		;UTF-7 translation
	CP_UTF8							= 65001		;UTF-8 translation


FILE_NOTIFY_INFORMATION struct
	NextEntryOffset		dd	?
	Action				dd	?
	FileNameLength		dd	?
	FileName			dw	?
FILE_NOTIFY_INFORMATION ends

									;NMHDR	STRUCT
NMHDR.hwndFrom	fix dword [EBX+0]		;.hwndFrom dd ?	;+0
NMHDR.idFrom	fix dword [EBX+4]		;.idFrom   dd ?	;+4
NMHDR.code		fix dword [EBX+8]		;.code     dd ?	;+8
									;NMHDR	ENDS

											;TOOLTIPTEXT STRUCT
TOOLTIPTEXT.hdr			fix	dword [EBX+0]		;hdr		NMHDR	<>		;+0
TOOLTIPTEXT.lpszText	fix	dword [EBX+12]		;lpszText	DWORD	?		;+12
TOOLTIPTEXT.szText		fix	dword [EBX+16]		;szText		BYTE 80 dup (?)	;+16
												;union
TOOLTIPTEXT.hInst		fix	dword [EBX+96]		;	hInst	dd	?			;+96
												;	hinst	dd	?
												;ends
TOOLTIPTEXT.uFlags		fix	dword [EBX+100]		;uFlags		DWORD	?		;+100
TOOLTIPTEXT.lParam		fix	dword [EBX+104]		;lParam		LPARAM	?		;+104
											;TOOLTIPTEXT ENDS

macro	MakeWindow
{
	mov		[wc.cbSize], sizeof.WNDCLASSEX
	mov		[wc.style], CS_HREDRAW or CS_VREDRAW or WS_TABSTOP
	mov		[wc.lpfnWndProc], WndProc
	mov		[wc.cbClsExtra], NULL
	mov		[wc.cbWndExtra], NULL
	push	[gIst]
	pop		[wc.hInstance]
	mov		[wc.hbrBackground], COLOR_BTNFACE + 1
;	mov		[wc.lpszMenuName], _MenuName
	mov		[wc.lpszClassName],  _ClassName
	invoke	LoadMenu, [wc.hInstance], 37
	mov		[gWnd], eax
	invoke	LoadIcon, [gIst], IDI_MAIN
	mov		[wc.hIcon], eax
	mov		[wc.hIconSm], eax
	invoke	LoadCursor, NULL, IDC_ARROW
	mov		[wc.hCursor], eax
	invoke	RegisterClassEx, wc
;---------- [Center the window] ----------
	invoke	GetSystemMetrics, SM_CXSCREEN
	sub		eax, MainWindWidth
	shr		eax, 1
	push	eax
	invoke	GetSystemMetrics, SM_CYSCREEN
	sub		eax, MainWindHeight
	shr		eax, 1
	pop		ecx

;---------- [Create the Main Window] ----------
	invoke	CreateWindowEx, WS_EX_CLIENTEDGE, _ClassName, _AppName, \
			WS_OVERLAPPEDWINDOW or WS_TABSTOP or WS_CLIPCHILDREN, \
			ecx, eax, 600, 500, NULL, [gWnd], \
			[gIst], NULL
	mov		[gWnd], eax
	invoke	LoadAccelerators, [gIst], _AppName
	mov		[hAccel], eax
	invoke	ShowWindow, [gWnd], SW_SHOWNORMAL
;	invoke	ShowWindow, [gWnd], SW_HIDE
	invoke	UpdateWindow, [gWnd]
	
 }

macro	CreateToolBar
{
;-----------[Create Tool Bar Window]
	invoke	CreateWindowEx, 0, _toolclass, 0, WS_CHILD or WS_VISIBLE or WS_BORDER or \
			TBSTYLE_TOOLTIPS or TBSTYLE_FLAT or \
			CCS_NOPARENTALIGN or CCS_NORESIZE or CCS_ADJUSTABLE, \
			0, -2, 325, 46, [gWnd], 0, [gIst], 0
	mov		[hwndTool], eax
;-----------[Create Image List]
	invoke	ImageList_Create, 32, 32, ILC_COLOR32, 7, 0
	mov		[hImageList], eax
;-----------[Load Bitmaps]
	mov		[id], 701
	mov		[cnt], 7
.an_bitmap:
	.while	[cnt], a, 0
		invoke	LoadImage, [gIst], [id], IMAGE_BITMAP, 32, 32, LR_DEFAULTCOLOR
		mov		[hImage], eax
		invoke	ImageList_Add, [hImageList], [hImage], NULL
		invoke	DeleteObject, [hImage]
		inc		[id]
		dec		[cnt]
	.endw
;	jnz		.an_bitmap
	invoke	SendMessage, [hwndTool], TB_BUTTONSTRUCTSIZE, sizeof.TBBUTTON, 0
	invoke	SendMessage, [hwndTool], TB_SETIMAGELIST, 0, [hImageList]
;-----------[Size the BitMaps and Buttons]
	mov		ecx, 32
	mov		eax, 32
	shl		eax, 16
	mov		ax, cx
	push	eax
	invoke	SendMessage, [hwndTool], TB_SETBITMAPSIZE, 0, eax
	pop		eax
	invoke	SendMessage, [hwndTool], TB_SETBUTTONSIZE, 0, eax
;---------- [Create the Toolbar structures] ----------

	TBButt	[hwndTool], 0, IDM_CREATE, 0	;Create
	TBSep	[hwndTool]
	TBButt	[hwndTool], 1, IDM_DELETE, 0	;Delete
	TBSep	[hwndTool]
	TBButt	[hwndTool], 2, IDM_MODIFY, 0	;Modify
	TBSep	[hwndTool]
	TBButt	[hwndTool], 3, IDM_RENAME, 0	;Rename
	TBSep	[hwndTool]
	TBButt	[hwndTool], 4, IDM_MOVEFR, 0	;MoveFrom
	TBSep	[hwndTool]
	TBButt	[hwndTool], 5, IDM_MOVETO, 0	;MoveTo
	TBSep	[hwndTool]
	TBButt	[hwndTool], 6, IDM_EXIT2, 0		;Exit2
	invoke	InvalidateRect, [gWnd], NULL, TRUE

}

macro	CreateListView
{
	invoke	CreateWindowEx, NULL, _ListViewClassName, \
			 NULL, LVS_REPORT + WS_CHILD + WS_VISIBLE, \
			 0, 46, 590, 405, [gWnd], NULL, [gIst], NULL
	mov		[hList], eax
	mov		eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP \
			  or LVS_EX_SUBITEMIMAGES or LVS_EX_GRIDLINES \
			  or LVS_SHOWSELALWAYS or LVS_OWNERDATA
	invoke	SendMessage, [hList], LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax
	mov		[lvc.mask], LVCF_TEXT+LVCF_WIDTH
	mov		[lvc.pszText], _LVHeading1
	mov		[lvc.cx], 200
	invoke	SendMessage, [hList], LVM_INSERTCOLUMN, 0, lvc
;	or		[lvc.mask], LVCF_FMT
;	mov		[lvc.fmt], LVCFMT_RIGHT
	mov		[lvc.pszText], _LVHeading2
	mov		[lvc.cx], 200
	invoke	SendMessage, [hList], LVM_INSERTCOLUMN, 1, lvc

}

macro	TBSep hTool
{
	mov		[tbb.iBitmap], 0
	mov		[tbb.idCommand], 0
	mov		[tbb.fsState], TBSTATE_ENABLED
	mov		[tbb.fsStyle], TBSTYLE_SEP					;1
	lea		eax, [tbb]
	invoke	SendMessage, hTool, TB_ADDBUTTONS, 1, eax
}

macro	TBButt hTool, BmpID, CmdID, Text
{
	mov		[tbb.iBitmap], BmpID
	mov		[tbb.idCommand], CmdID
	mov		[tbb.fsState], TBSTATE_ENABLED			;4
	mov		[tbb.fsStyle], TBSTYLE_BUTTON			;0
	mov		[tbb.dwData], 0
	mov		[tbb.iString], Text
	lea		eax, [tbb]
	invoke	SendMessage, hTool, TB_ADDBUTTONS, 1, eax
}

macro	CheckFiles
;CheckFiles creates in the folder this program is run from, at least two files
;	Raw.txt
;	Working.txt
;The 6 operations which can take place are:
;	Create		Creates a new file with 'CreateFN.fc' name
;	Delete		Deletes the file 'RawFN.fc'; then that file is recreated
;	Modify		Modifies the file 'RawFN.fc' by adding 10 bytes
;	Rename		Renames the file 'RawFN.fc' to 'RenameFN.fc'; then the file 'RawFN.fc' is recreated
;	MoveFrom	Moves the file 'RawFN.fc' to the root directory with a unique name generated by GetTempFileName
;	MoveTo		Creates a file in the root directory with a unique name generated by GetTempFileName, then move it to this dir
{
	invoke	GetModuleFileName, 0, TA_PathBuf, MAX_PATH
	.if eax, e, 0
		jmp	.CF_dir_out
	.endif													;eax contains size of returned path string
	add		eax, TA_PathBuf									;eax points to end of FileName
															;now remove app's filename, up to last "\"
@@:	dec		eax												; dec eax
	cmp		[eax], BYTE '\'									; compare if "\"
	jne		@B												; jump back to @@: if not "\"
    mov		[eax+1], BYTE 0									; write zero terminator after "\"
    invoke	lstrcpy, PathBuf, TA_PathBuf
	mov		[lvi.mask], LVIF_TEXT
	inc		[lvi.iItem]
	mov		[lvi.iSubItem], 0
;	invoke	WideCharToMultiByte, CP_ACP, NULL, addr local__buf, -1, TA_PathBuf, MAX_PATH, NULL, NULL
	mov		[lvi.pszText], TA_PathBuf
	invoke	SendMessage, [hList], LVM_INSERTITEM, 0, lvi
;PathBuf now contains this apps' folder name
	invoke	lstrcat, PathBuf, _RawFN						;
	invoke	CreateFile, PathBuf, GENERIC_READ or GENERIC_WRITE, \
			FILE_SHARE_DELETE or FILE_SHARE_READ or FILE_SHARE_WRITE, \
			NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	.if eax, e, INVALID_HANDLE_VALUE						;File 'RawFN.fc' could not be created
		mov	eax, 0
		jmp	.CF_dir_out
	.endif
	mov		[hRawFN], eax
	mov		[bufRawFN], 04030201h
	.repeat
		invoke	WriteFile, [hRawFN], bufRawFN, 4, bufNOBW, NULL
		add		[bufRawFN], 01010101h
	.until	[bufRawFN], a, 090000000h
	invoke	CloseHandle, [hRawFN]
.done_Check:
	mov	eax, 1
.CF_dir_out:
	
}

;macro	DelFiles
;Deletes any files created in CheckFiles and during the program
;{
;	
;}

macro	FC_Create
{
	mov		[gListAct], 1
    invoke	lstrcpy, PathBuf, TA_PathBuf
	invoke	lstrcat, PathBuf, _CreateFN						;
	invoke	CreateFile, PathBuf, GENERIC_READ or GENERIC_WRITE, \
			FILE_SHARE_DELETE or FILE_SHARE_READ or FILE_SHARE_WRITE, \
			NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	invoke	CloseHandle, eax
	mov		[gListAct], 0
	invoke	DeleteFile, PathBuf
}

macro	FC_Delete
{
	mov		[gListAct], 1
	invoke	lstrcpy, PathBuf, TA_PathBuf
;PathBuf now contains this apps' folder name
	invoke	lstrcat, PathBuf, _RawFN						;
	invoke	DeleteFile, PathBuf
;now recreate RawFN.fc file
	mov		[gListAct], 0
	invoke	CreateFile, PathBuf, GENERIC_READ or GENERIC_WRITE, \
			FILE_SHARE_DELETE or FILE_SHARE_READ or FILE_SHARE_WRITE, \
			NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	.if eax, e, INVALID_HANDLE_VALUE						;File 'RawFN.fc' could not be created
		mov	eax, 0
		jmp	.CF_dir_out
	.endif
	mov		[hRawFN], eax
	mov		[bufRawFN], 04030201h
@@:	.repeat
		invoke	WriteFile, [hRawFN], bufRawFN, 4, bufNOBW, NULL
		add		[bufRawFN], 01010101h
	.until	[bufRawFN], a, 090000000h
	invoke	CloseHandle, [hRawFN]

 }

macro	FC_Modify
{
	mov		[gListAct], 1
	invoke	lstrcpy, PathBuf, TA_PathBuf
;PathBuf now contains this apps' folder name
	invoke	lstrcat, PathBuf, _RawFN						;
	invoke	CreateFile, PathBuf, GENERIC_READ or GENERIC_WRITE, \
			FILE_SHARE_DELETE or FILE_SHARE_READ or FILE_SHARE_WRITE, \
			NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	mov		[hRawFN], eax
	invoke	SetFilePointer, eax, 0, 0, FILE_END
	mov		[bufRawFN], 04030201h
	.repeat
		invoke	WriteFile, [hRawFN], bufRawFN, 4, bufNOBW, NULL
		add		[bufRawFN], 01010101h
	.until	[bufRawFN], a, 090000000h
	invoke	CloseHandle, [hRawFN]

}

macro	FC_Rename
{
	mov		[gListAct], 1
	mov		[gDone], 0
	invoke	lstrcpy, PathBuf, TA_PathBuf
;PathBuf now contains this apps' folder name
	invoke	lstrcat, PathBuf, _RawFN
	invoke	lstrcpy, TmpPath, TA_PathBuf
	invoke	DeleteFile, TmpPath
;PathBuf now contains this apps' folder name
	invoke	lstrcat, TmpPath, _RenameFN
	invoke	MoveFile, PathBuf, TmpPath
;	invoke	MoveFileEx, PathBuf, TmpPath, MOVEFILE_REPLACE_EXISTING or MOVEFILE_WRITE_THROUGH
	.if eax, e, 0
;		int 3
		invoke MessageBox, 0, 'Not Moved', NULL, MB_OK
	.endif
;now delete RenameFN.fc & recreate RawFN.fc file
	invoke	SetTimer, [hwnd], 5432, 1000, NULL
	mov		[DRtimer], 1
}

macro	FC_MoveFr
;This will use MoveFile to move 'RawFN.fc' from this apps' dir to the root dir, then it will be deleted
{
	mov		[gListAct], 1
	invoke	lstrcpy, PathBuf, TA_PathBuf
;PathBuf now contains this apps' folder name
	invoke	lstrcat, PathBuf, _RawFN
	invoke	lstrcpy, TmpPath, _Root
	invoke	lstrcat, TmpPath, _RawFN
	invoke	MoveFile, PathBuf, TmpPath
	.if eax, e, 0
;		int 3
		invoke MessageBox, 0, 'Not Moved', NULL, MB_OK
	.endif
	mov		[gListAct], 0
	invoke	MoveFile, TmpPath, PathBuf
}

macro	FC_MoveTo
;this will create a temp file in the root dir and then move that file into this apps' dir
{
	mov		[gListAct], 1
	invoke	GetTempFileName, _Root, _New, 0, TmpPath
	invoke	CreateFile, TmpPath, GENERIC_READ or GENERIC_WRITE, NULL, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	invoke	CloseHandle, eax
	invoke	lstrcpy, PathBuf, TA_PathBuf
	mov		eax, TmpPath
	add		eax, 1
	invoke	lstrcat, PathBuf, eax
	invoke	MoveFile, TmpPath, PathBuf
	mov		[gListAct], 0
	invoke	DeleteFile, PathBuf
}

macro	DelayRename
{
	mov		[gListAct], 0
	invoke	DeleteFile, TmpPath
	invoke	CreateFile, PathBuf, GENERIC_READ or GENERIC_WRITE, \
			FILE_SHARE_DELETE or FILE_SHARE_READ or FILE_SHARE_WRITE, \
			NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	.if eax, e, INVALID_HANDLE_VALUE						;File 'RawFN.fc' could not be created
		mov	eax, 0
		jmp	.CF_dir_out
	.endif
	mov		[hRawFN], eax
	mov		[bufRawFN], 04030201h
	.repeat
	invoke	WriteFile, [hRawFN], bufRawFN, 4, bufNOBW, NULL
		add		[bufRawFN], 01010101h
	.until	[bufRawFN], a, 090000000h
	invoke	CloseHandle, [hRawFN]
}

jdwtoa	proc dwValue, lpBuffer, DivOrNo
;____________________________________________________________________
    ; -----------------------------------------
    ; This procedure was written by Tim Roberts
    ; -----------------------------------------
    ; Modified slightly by Farrier to return a '0' when dwValue = 0
    ; and with DivOrNo, add separators, ie. '1,234,567'
    ; -------------------------------------------------------------
    ; convert DWORD to ascii string
    ; dwValue is value to be converted
    ; lpBuffer is the address of the receiving buffer
    ; EXAMPLE:
    ; stdcall jdwtoa, edx, addr buffer, 0
    ;
    ; Uses: eax, ecx, edx, esi, edi.
    ; -------------------------------------------------------------

	push	ebx
	push	edi
	push	esi
	mov		eax, [dwValue]
	mov		edi, [lpBuffer]
	cmp		eax, 0
	jne	.not_zero
		mov	byte [edi], '0'
		inc	edi
		mov	byte [edi], 0
		jmp	.dir_out
.not_zero:
; Is the value negative?
	jg	.positive
		mov byte [edi], '-'   ;store a minus sign
		inc edi
		neg eax                   ;and invert the value
.positive:
	mov	esi, edi				;save pointer to first digit
	mov	ecx, 10
;    .while (eax > 0)			;while there is more to convert...
.another_10:
		xor edx, edx			;clear edx for edx:eax div ecx
		div ecx					;leaves remainder--"next digit"--in edx
		add dl, '0'				;convert to ASCII
		mov [edi], dl			;store it
		inc edi
		cmp	eax, 0				;are we done
		jne	.another_10			;if not, divide again
;    .endw
	mov byte [edi], 0       ;terminate the string
; We now have all the digits, but in reverse order.
;    .while (esi < edi)
;	mov	ebx, 0				;keep track for commas
	mov		eax, edi
	sub		eax, esi
	cmp		[DivOrNo], 0
	je		.dont_push
	push	eax
.dont_push:
	dec		eax
	mov		ecx, 3
	mov		edx, 0
	div		cx
	mov		ebx, eax			;ebx holds # of commas
.switch_another:
		dec edi				;at this point esi is pointer to beginning of buffer, most signif.
							;edi points to last converted digit, least significant
		mov al, [esi]
		mov ah, [edi]
		mov [edi], al
		mov [esi], ah
		inc esi
;		inc	ebx
		cmp	esi, edi
		jb	.switch_another
;    .endw
.get_out:
	cmp		[DivOrNo], 0
	je		.dir_out
	mov		edx, 0
	mov		edi, [lpBuffer]	;most sig digit
	mov		esi, edi
	pop		eax				;length of string
	add		edi, eax		;points to least sig. digit
	mov		ecx, edi
	dec		ecx
	add		edi, ebx		;make space for commas
;	inc		edi				;make space for term. 0
	mov		byte [edi], 0	;new string termination
	dec		edi
.anot_dig:
	mov		al, [ecx]
	mov		[edi], al
	inc		edx
	dec		ecx
	dec		edi
	cmp		edi, esi
	je		.dir_out
	cmp		edi, ecx
	je		.dir_out
	cmp		edx, 3
	jne		.anot_dig
	mov		byte [edi], ','
	mov		edx, 0
	dec		edi
	cmp		edi, ecx
	jne		.anot_dig
.dir_out:
	pop		esi
	pop		edi
	pop		ebx
	ret

jdwtoa	endp